Skip to content

Get device

GET
/v1alpha/inventory/devices/{id}
id
required
string
/[^/]+/
fqn
string

A successful response.

Media typeapplication/json
object
device

Device represents a physical or virtual screen / sensor deployed in a retail location.

object
metadata

The metadata of the device.

object
id
read-only

The unique identifier for the resource.

string
fqn
read-only

The fully qualified name of the resource.

string
name

The name of the resource.

string
firstCreatedAt
read-only

The timestamp when the resource was first created.

string format: date-time
lastUpdatedAt
read-only

The timestamp when the resource was last updated.

string format: date-time
revision
read-only

The revision of the resource. Must be empty if the resource is not under version control.

object
id
read-only

The unique identifier for a particular revision of the resource.

string
createdAt
read-only

The timestamp when this particular revision was created.

string format: date-time
latestId
read-only

The unique identifier for the latest revision of the resource. Must be empty if this is already the latest revision.

string
labels

The labels of the resource.

object
key
additional properties
string
mask

The fields to patch in the device.

string
location

The location where this device is installed.

object
id

Deprecated. Use external_id instead. Setting this to “externalid:” is still supported, but prefer external_id going forward.

string
externalId

The location’s external id (e.g. its TDLinx code). The location doesn’t have to be one you created — the same physical store may already be registered by another partner.

string
type

The type of this device.

string
default: DEVICE_TYPE_UNSPECIFIED
Allowed values: DEVICE_TYPE_UNSPECIFIED DEVICE_TYPE_CHECKOUT_TV DEVICE_TYPE_STELE DEVICE_TYPE_POLARLIGHT DEVICE_TYPE_SPOTLIGHT_ONE DEVICE_TYPE_EXCLUSIVE DEVICE_TYPE_DCLP DEVICE_TYPE_SPOTLIGHT DEVICE_TYPE_EXCLUSIVE_SCREEN DEVICE_TYPE_PRICE_BOARD DEVICE_TYPE_HANDHELD
status

The operational status of the device.

string
default: STATUS_UNSPECIFIED
Allowed values: STATUS_UNSPECIFIED STATUS_INACTIVE STATUS_ACTIVE
deployment

The deployment this device belongs to.

object
allocationTargets

The allocation targets of the deployment.

Array<object>

AllocationTarget wraps the concrete allocation target types inside a Deployment.

object
static

Static is an allocation target that routes a fixed percentage of impressions to one or more ad or content servers (e.g. on-site / venue-sourced).

object
percentage

Share of impressions to allocate (0–100).

number format: double
adServers
Array<object>
object
reference

Identifier of the referenced AdServer entity.

object
id
string
fqn
string
resource

Any contains an arbitrary serialized protocol buffer message along with a URL that describes the type of the serialized message.

Protobuf library provides support to pack/unpack Any values in the form of utility functions or additional generated methods of the Any type.

Example 1: Pack and unpack a message in C++.

Foo foo = ...;
Any any;
any.PackFrom(foo);
...
if (any.UnpackTo(&foo)) {
  ...
}

Example 2: Pack and unpack a message in Java.

Foo foo = ...;
Any any = Any.pack(foo);
...
if (any.is(Foo.class)) {
  foo = any.unpack(Foo.class);
}
// or ...
if (any.isSameTypeAs(Foo.getDefaultInstance())) {
  foo = any.unpack(Foo.getDefaultInstance());
}

Example 3: Pack and unpack a message in Python.

foo = Foo(...)
any = Any()
any.Pack(foo)
...
if any.Is(Foo.DESCRIPTOR):
  any.Unpack(foo)
  ...

Example 4: Pack and unpack a message in Go

 foo := &pb.Foo{...}
 any, err := anypb.New(foo)
 if err != nil {
   ...
 }
 ...
 foo := &pb.Foo{}
 if err := any.UnmarshalTo(foo); err != nil {
   ...
 }

The pack methods provided by protobuf library will by default use ‘type.googleapis.com/full.type.name’ as the type URL and the unpack methods only use the fully qualified type name after the last ’/’ in the type URL, for example “foo.bar.com/x/y.z” will yield type name “y.z”.

JSON

The JSON representation of an Any value uses the regular representation of the deserialized, embedded message, with an additional field @type which contains the type URL. Example:

package google.profile;
message Person {
  string first_name = 1;
  string last_name = 2;
}

{
  "@type": "type.googleapis.com/google.profile.Person",
  "firstName": <string>,
  "lastName": <string>
}

If the embedded message type is well-known and has a custom JSON representation, that representation will be embedded adding a field value which holds the custom JSON in addition to the @type field. Example (for message [google.protobuf.Duration][]):

{
  "@type": "type.googleapis.com/google.protobuf.Duration",
  "value": "1.212s"
}
object
@type

A URL/resource name that uniquely identifies the type of the serialized protocol buffer message. This string must contain at least one ”/” character. The last segment of the URL’s path must represent the fully qualified name of the type (as in path/google.protobuf.Duration). The name should be in a canonical form (e.g., leading ”.” is not accepted).

In practice, teams usually precompile into the binary all types that they expect it to use in the context of Any. However, for URLs which use the scheme http, https, or no scheme, one can optionally set up a type server that maps type URLs to message definitions as follows:

  • If no scheme is provided, https is assumed.
  • An HTTP GET on the URL must yield a [google.protobuf.Type][] value in binary format, or produce an error.
  • Applications are allowed to cache lookup results based on the URL, or have them precompiled into a binary to avoid any lookup. Therefore, binary compatibility needs to be preserved on changes to types. (Use versioned type names to manage breaking changes.)

Note: this functionality is not currently available in the official protobuf release, and it is not used for type URLs beginning with type.googleapis.com. As of May 2023, there are no widely used type server implementations and no plans to implement one.

Schemes other than http, https (or the empty scheme) might be used with implementation specific semantics.

string
key
additional properties
nonStatic

NonStatic is an allocation target that routes remaining percentage to internal SSP.

object
adServers
Array<object>
object
reference

Identifier of the referenced AdServer entity.

object
id
string
fqn
string
resource

Any contains an arbitrary serialized protocol buffer message along with a URL that describes the type of the serialized message.

Protobuf library provides support to pack/unpack Any values in the form of utility functions or additional generated methods of the Any type.

Example 1: Pack and unpack a message in C++.

Foo foo = ...;
Any any;
any.PackFrom(foo);
...
if (any.UnpackTo(&foo)) {
  ...
}

Example 2: Pack and unpack a message in Java.

Foo foo = ...;
Any any = Any.pack(foo);
...
if (any.is(Foo.class)) {
  foo = any.unpack(Foo.class);
}
// or ...
if (any.isSameTypeAs(Foo.getDefaultInstance())) {
  foo = any.unpack(Foo.getDefaultInstance());
}

Example 3: Pack and unpack a message in Python.

foo = Foo(...)
any = Any()
any.Pack(foo)
...
if any.Is(Foo.DESCRIPTOR):
  any.Unpack(foo)
  ...

Example 4: Pack and unpack a message in Go

 foo := &pb.Foo{...}
 any, err := anypb.New(foo)
 if err != nil {
   ...
 }
 ...
 foo := &pb.Foo{}
 if err := any.UnmarshalTo(foo); err != nil {
   ...
 }

The pack methods provided by protobuf library will by default use ‘type.googleapis.com/full.type.name’ as the type URL and the unpack methods only use the fully qualified type name after the last ’/’ in the type URL, for example “foo.bar.com/x/y.z” will yield type name “y.z”.

JSON

The JSON representation of an Any value uses the regular representation of the deserialized, embedded message, with an additional field @type which contains the type URL. Example:

package google.profile;
message Person {
  string first_name = 1;
  string last_name = 2;
}

{
  "@type": "type.googleapis.com/google.profile.Person",
  "firstName": <string>,
  "lastName": <string>
}

If the embedded message type is well-known and has a custom JSON representation, that representation will be embedded adding a field value which holds the custom JSON in addition to the @type field. Example (for message [google.protobuf.Duration][]):

{
  "@type": "type.googleapis.com/google.protobuf.Duration",
  "value": "1.212s"
}
object
@type

A URL/resource name that uniquely identifies the type of the serialized protocol buffer message. This string must contain at least one ”/” character. The last segment of the URL’s path must represent the fully qualified name of the type (as in path/google.protobuf.Duration). The name should be in a canonical form (e.g., leading ”.” is not accepted).

In practice, teams usually precompile into the binary all types that they expect it to use in the context of Any. However, for URLs which use the scheme http, https, or no scheme, one can optionally set up a type server that maps type URLs to message definitions as follows:

  • If no scheme is provided, https is assumed.
  • An HTTP GET on the URL must yield a [google.protobuf.Type][] value in binary format, or produce an error.
  • Applications are allowed to cache lookup results based on the URL, or have them precompiled into a binary to avoid any lookup. Therefore, binary compatibility needs to be preserved on changes to types. (Use versioned type names to manage breaking changes.)

Note: this functionality is not currently available in the official protobuf release, and it is not used for type URLs beginning with type.googleapis.com. As of May 2023, there are no widely used type server implementations and no plans to implement one.

Schemes other than http, https (or the empty scheme) might be used with implementation specific semantics.

string
key
additional properties
balancePolicy
string
default: AD_SERVER_BALANCE_POLICY_UNSPECIFIED
Allowed values: AD_SERVER_BALANCE_POLICY_UNSPECIFIED AD_SERVER_BALANCE_POLICY_BIDDING
adNetworks
Ad Network
Array<string>
supportedAdTypes

Supported Ad types maps ad type names (e.g. “display”) to their accepted formats.

Array<object>

SupportedAdType holds the list of accepted formats for one ad type slot.

object
adType
string
default: AD_TYPE_UNSPECIFIED
Allowed values: AD_TYPE_UNSPECIFIED AD_TYPE_DISPLAY
formats
Array<string>
externalId
Device unique external identifier in the format "{identifier.key}_{identifier.player_id}"
string
identifier
Same as external_id but separated into key and player_id
object
key
string
playerId
string
screenCount

Number of physical screens at this position.

integer format: int32
sensors
Array<string>
Allowed values: SENSOR_UNSPECIFIED SENSOR_VISION SENSOR_DEMOGRAPHICS SENSOR_ADVERTIMA SENSOR_BASKET SENSOR_LOCATION
deviceOwner

Network operator / CMS partner that manages this device, e.g. “Viewento”.

string
playoutImpressionFactors

Playout impression multipliers, per weekday and optional time range. Windows not covered by any rule default to a factor of 0.

Array<object>

ImpressionFactor sets the playout impression multiplier for a recurring weekly window. An unset start/end means it applies to the whole day.

object
day

Represents a day of the week.

  • DAY_OF_WEEK_UNSPECIFIED: The day of the week is unspecified.
  • MONDAY: Monday
  • TUESDAY: Tuesday
  • WEDNESDAY: Wednesday
  • THURSDAY: Thursday
  • FRIDAY: Friday
  • SATURDAY: Saturday
  • SUNDAY: Sunday
string
default: DAY_OF_WEEK_UNSPECIFIED
Allowed values: DAY_OF_WEEK_UNSPECIFIED MONDAY TUESDAY WEDNESDAY THURSDAY FRIDAY SATURDAY SUNDAY
start

Represents a time of day. The date and time zone are either not significant or are specified elsewhere. An API may choose to allow leap seconds. Related types are [google.type.Date][google.type.Date] and google.protobuf.Timestamp.

object
hours

Hours of a day in 24 hour format. Must be greater than or equal to 0 and typically must be less than or equal to 23. An API may choose to allow the value “24:00:00” for scenarios like business closing time.

integer format: int32
minutes

Minutes of an hour. Must be greater than or equal to 0 and less than or equal to 59.

integer format: int32
seconds

Seconds of a minute. Must be greater than or equal to 0 and typically must be less than or equal to 59. An API may allow the value 60 if it allows leap-seconds.

integer format: int32
nanos

Fractions of seconds, in nanoseconds. Must be greater than or equal to 0 and less than or equal to 999,999,999.

integer format: int32
end

Represents a time of day. The date and time zone are either not significant or are specified elsewhere. An API may choose to allow leap seconds. Related types are [google.type.Date][google.type.Date] and google.protobuf.Timestamp.

object
hours

Hours of a day in 24 hour format. Must be greater than or equal to 0 and typically must be less than or equal to 23. An API may choose to allow the value “24:00:00” for scenarios like business closing time.

integer format: int32
minutes

Minutes of an hour. Must be greater than or equal to 0 and less than or equal to 59.

integer format: int32
seconds

Seconds of a minute. Must be greater than or equal to 0 and typically must be less than or equal to 59. An API may allow the value 60 if it allows leap-seconds.

integer format: int32
nanos

Fractions of seconds, in nanoseconds. Must be greater than or equal to 0 and less than or equal to 999,999,999.

integer format: int32
factor

Per-playout impression multiplier for this window. Fractional: DOOH hourly multipliers are derived as (hourly contacts / playouts) and are almost always non-integer, e.g. 3.33 (IDOOH/PuPS). Carry the exact value here and round only at aggregate/report time — never per playout.

number format: double
excludedAdProducts

Advertising-industry taxonomy categories that must not be served on this device.

Array<string>
Allowed values: AD_PRODUCT_UNSPECIFIED AD_PRODUCT_GENERAL AD_PRODUCT_RELIGION AD_PRODUCT_EROTIC_CONTENT AD_PRODUCT_FUNERAL_SERVICES AD_PRODUCT_BEVERAGES AD_PRODUCT_NON_ALCOHOLIC_BEVERAGES AD_PRODUCT_BEER AD_PRODUCT_BEVERAGES_GENERAL AD_PRODUCT_BEVERAGES_CORPORATE_IMAGE_ADVERTISING AD_PRODUCT_COFFEE_TEA_COCOA AD_PRODUCT_SPARKLING_WINE AD_PRODUCT_WINE AD_PRODUCT_SPIRITS AD_PRODUCT_FINANCE AD_PRODUCT_RETIREMENT_PROVISION AD_PRODUCT_FINANCIAL_SERVICES_CORPORATE_CLIENTS AD_PRODUCT_FINANCIAL_SERVICES_PRIVATE_CLIENTS AD_PRODUCT_FINANCIAL_INVESTMENTS AD_PRODUCT_FINANCE_GENERAL AD_PRODUCT_FINANCE_CORPORATE_IMAGE_ADVERTISING AD_PRODUCT_INSURANCE AD_PRODUCT_SERVICES AD_PRODUCT_EQUIPMENT_LEASING_RENTAL AD_PRODUCT_VOCATIONAL_TRAINING AD_PRODUCT_CAR_WASHES AD_PRODUCT_CONSULTING_SERVICES AD_PRODUCT_SERVICES_GENERAL AD_PRODUCT_SERVICES_CORPORATE_IMAGE_ADVERTISING AD_PRODUCT_SERVICES_OTHER AD_PRODUCT_PRINTING_COMPANIES AD_PRODUCT_IT_SERVICES AD_PRODUCT_PROPERTY_MANAGEMENT AD_PRODUCT_DELIVERY_SERVICES AD_PRODUCT_PUBLIC_CORPORATIONS AD_PRODUCT_LOTTERIES_LOTTO_SPORTS_BETTING AD_PRODUCT_MARKETING_ADVERTISING AD_PRODUCT_MARKET_RESEARCH AD_PRODUCT_TRADE_FAIRS_EXHIBITIONS_SEMINARS AD_PRODUCT_ONLINE_SERVICES AD_PRODUCT_TELEPHONE_FAX_SERVICES AD_PRODUCT_BROKERAGE_SERVICES AD_PRODUCT_LEGAL_AND_BUSINESS_CONSULTING AD_PRODUCT_CAPITAL_GOODS AD_PRODUCT_DRIVES_BEARINGS AD_PRODUCT_COMMERCIAL_INDUSTRIAL_FURNISHING AD_PRODUCT_CAPITAL_GOODS_GENERAL AD_PRODUCT_CAPITAL_GOODS_CORPORATE_IMAGE_ADVERTISING AD_PRODUCT_CAPITAL_GOODS_OTHER AD_PRODUCT_MACHINERY_SYSTEMS AD_PRODUCT_MACHINERY_INDUSTRY_AGRICULTURE AD_PRODUCT_TOOLS AD_PRODUCT_HEALTH_PHARMACEUTICALS AD_PRODUCT_MEDICINES AD_PRODUCT_HEALTH_CARE_FACILITIES AD_PRODUCT_HEALTH_PHARMACEUTICALS_GENERAL AD_PRODUCT_HEALTH_PHARMACEUTICALS_OTHER AD_PRODUCT_HEALTH_PHARMACEUTICALS_CORPORATE_IMAGE_ADVERTISING AD_PRODUCT_MEDICAL_DEVICES AD_PRODUCT_OPTICS AD_PRODUCT_SPORT_DIET_PROGRAMS AD_PRODUCT_ACOUSTICS AD_PRODUCT_CLINICS_SANATORIUMS_AND_DOCTORS AD_PRODUCT_CONSUMER_ELECTRONICS AD_PRODUCT_AUDIO_DEVICES AD_PRODUCT_PHOTOGRAPHY AD_PRODUCT_CONSUMER_ELECTRONICS_GENERAL AD_PRODUCT_GAMES_GAMING_COMPUTERS AD_PRODUCT_CONSUMER_ELECTRONICS_CORPORATE_IMAGE_ADVERTISING AD_PRODUCT_PERSONAL_CARE AD_PRODUCT_BABY_CARE AD_PRODUCT_DECORATIVE_COSMETICS AD_PRODUCT_BODY_CARE AD_PRODUCT_FACIAL_CARE AD_PRODUCT_HAIR_CARE AD_PRODUCT_PERSONAL_HYGIENE AD_PRODUCT_PERSONAL_CARE_CORPORATE_IMAGE_ADVERTISING AD_PRODUCT_PERFUMES_FRAGRANCE_PRODUCTS AD_PRODUCT_CARE_COSMETICS_COMPLETE_SERIES AD_PRODUCT_HOME_GARDEN_FURNISHINGS AD_PRODUCT_BATHROOM_SANITARY AD_PRODUCT_HOUSEHOLD_ELECTRICAL_APPLIANCES AD_PRODUCT_FLOORING AD_PRODUCT_GARDENING_AGRICULTURE AD_PRODUCT_GARDEN_TOOLS AD_PRODUCT_TABLEWARE_GLASSWARE AD_PRODUCT_HOME_GARDEN_FURNISHINGS_CORPORATE_IMAGE_ADVERTISING AD_PRODUCT_HOME_GARDEN_FURNISHINGS_GENERAL AD_PRODUCT_HOUSEHOLD_ARTICLES AD_PRODUCT_LIGHTING_TECHNOLOGY AD_PRODUCT_AWNINGS_BLINDS AD_PRODUCT_FURNITURE_FURNISHINGS AD_PRODUCT_SECURITY_ALARM_DEVICES AD_PRODUCT_CONSTRUCTION_INDUSTRY AD_PRODUCT_BUILDING_MATERIALS_ACCESSORIES AD_PRODUCT_CONSTRUCTION_INDUSTRY_GENERAL AD_PRODUCT_CONSTRUCTION_INDUSTRY_CORPORATE_IMAGE_ADVERTISING AD_PRODUCT_CONSTRUCTION_MACHINERY AD_PRODUCT_PAINTS_WALLPAPER AD_PRODUCT_REAL_ESTATE AD_PRODUCT_TEXTILES_CLOTHING AD_PRODUCT_CLOTHING AD_PRODUCT_TEXTILES_CLOTHING_CORPORATE_IMAGE_ADVERTISING AD_PRODUCT_TEXTILES_CLOTHING_GENERAL AD_PRODUCT_HOME_TEXTILES AD_PRODUCT_LEATHER_GOODS AD_PRODUCT_FURS AD_PRODUCT_SHOES AD_PRODUCT_UNDERWEAR AD_PRODUCT_MEDIA AD_PRODUCT_VIDEO_AUDIO_MEDIA_MUSIC AD_PRODUCT_TRADE_MAGAZINE_ADVERTISING AD_PRODUCT_FILM AD_PRODUCT_TV_PROGRAM AD_PRODUCT_TV_ADVERTISING AD_PRODUCT_NEWSPAPER_ADVERTISING AD_PRODUCT_MEDIA_CORPORATE_IMAGE_ADVERTISING AD_PRODUCT_CONSUMER_MAGAZINE_ADVERTISING AD_PRODUCT_RADIO_ADVERTISING AD_PRODUCT_OTHER_MEDIA_PUBLISHERS AD_PRODUCT_FOOD_NUTRITION AD_PRODUCT_BREAD_LONG_LIFE_BAKED_GOODS AD_PRODUCT_SPREADS AD_PRODUCT_DESSERTS AD_PRODUCT_DIET_SPORTS_NUTRITION AD_PRODUCT_FOOD_GENERAL AD_PRODUCT_FOOD_CORPORATE_IMAGE_ADVERTISING AD_PRODUCT_DELICATESSEN AD_PRODUCT_MEAT_FISH AD_PRODUCT_FRUITS_VEGETABLES AD_PRODUCT_SPICES_SEASONING_SAUCES AD_PRODUCT_FROZEN_FOOD AD_PRODUCT_DAIRY_PRODUCTS_YELLOW_LINE AD_PRODUCT_DAIRY_PRODUCTS_WHITE_LINE AD_PRODUCT_STAPLE_FOODS AD_PRODUCT_CONFECTIONERY AD_PRODUCT_BAKERIES_PASTRY_SHOPS AD_PRODUCT_OTHER_ADVERTISING AD_PRODUCT_CHARITABLE_ORGANIZATIONS AD_PRODUCT_CLASSIFIED_ADVERTISING AD_PRODUCT_CORPORATE_ADVERTISING AD_PRODUCT_COMPUTER_OFFICE AD_PRODUCT_COMPUTERS_PERIPHERALS AD_PRODUCT_COMPUTER_OFFICE_GENERAL AD_PRODUCT_SOFTWARE AD_PRODUCT_OTHER_OFFICE_EQUIPMENT_PAPER AD_PRODUCT_ENERGY AD_PRODUCT_ENERGY_GENERAL AD_PRODUCT_ENERGY_CORPORATE_IMAGE_ADVERTISING AD_PRODUCT_ENERGY_SUPPLY AD_PRODUCT_HEATING_TECHNOLOGY AD_PRODUCT_FUELS_LUBRICANTS AD_PRODUCT_ELECTRICITY_PROVIDERS AD_PRODUCT_ELECTRICITY_PROVIDERS_ELECTROMOBILITY AD_PRODUCT_GAS_STATIONS AD_PRODUCT_AUTOMOTIVE_MARKET AD_PRODUCT_VEHICLE_SERVICE AD_PRODUCT_VEHICLE_ACCESSORIES AD_PRODUCT_TWO_WHEELER_INDUSTRY AD_PRODUCT_AUTOMOTIVE_MARKET_CORPORATE_IMAGE_ADVERTISING AD_PRODUCT_AUTOMOTIVE_MARKET_GENERAL AD_PRODUCT_CARAVANS_MOTORHOMES AD_PRODUCT_COMMERCIAL_VEHICLES AD_PRODUCT_PASSENGER_CARS AD_PRODUCT_TIRES AD_PRODUCT_TRANSPORT_LOGISTICS AD_PRODUCT_VEHICLE_RENTAL AD_PRODUCT_AVIATION AD_PRODUCT_ROAD_RAIL_TRANSPORT AD_PRODUCT_TRANSPORT_LOGISTICS_GENERAL AD_PRODUCT_TRANSPORT_LOGISTICS_CORPORATE_IMAGE_ADVERTISING AD_PRODUCT_TELECOMMUNICATIONS AD_PRODUCT_LANDLINE AD_PRODUCT_TELECOMMUNICATIONS_GENERAL AD_PRODUCT_TELECOMMUNICATIONS_CORPORATE_IMAGE_ADVERTISING AD_PRODUCT_TELECOMMUNICATIONS_BUNDLES AD_PRODUCT_TELECOMMUNICATIONS_OTHER AD_PRODUCT_TELECOMMUNICATIONS_DEVICES AD_PRODUCT_MOBILE_NETWORK AD_PRODUCT_HOUSEHOLD_AGRICULTURE_FORESTRY_HUNTING AD_PRODUCT_FISHING_HUNTING_WEAPONS AD_PRODUCT_PET_FOOD AD_PRODUCT_ANIMAL_CARE AD_PRODUCT_TOURISM AD_PRODUCT_AIRLINES_AIR_TRAVEL AD_PRODUCT_VISITOR_TOURISM AD_PRODUCT_TOURISM_GENERAL AD_PRODUCT_TOURISM_CORPORATE_IMAGE_ADVERTISING AD_PRODUCT_TRAVEL_COMPANIES AD_PRODUCT_CRUISE_LINES_SEA_TRAVEL AD_PRODUCT_LEISURE_SPORT AD_PRODUCT_LEISURE_SPORT_CORPORATE_IMAGE_ADVERTISING AD_PRODUCT_SPORT_CAMPING AD_PRODUCT_TRADE AD_PRODUCT_TRADE_GENERAL AD_PRODUCT_TRADE_CORPORATE_IMAGE_ADVERTISING AD_PRODUCT_TRADE_OTHER AD_PRODUCT_FOOD_RETAIL AD_PRODUCT_FOOD_WHOLESALE AD_PRODUCT_DEPARTMENT_STORES AD_PRODUCT_EXPORT_IMPORT AD_PRODUCT_DRUGSTORES AD_PRODUCT_BEVERAGE_STORES AD_PRODUCT_OUTLET_CENTERS AD_PRODUCT_ELECTRONICS_STORES AD_PRODUCT_BAKERIES AD_PRODUCT_RETAIL_OTHER AD_PRODUCT_GASTRONOMY AD_PRODUCT_HOTELS AD_PRODUCT_HOTELS_GASTRONOMY_CORPORATE_IMAGE_ADVERTISING AD_PRODUCT_HOTELS_GASTRONOMY_E_COMMERCE AD_PRODUCT_INDUSTRIAL_CONSUMER_GOODS AD_PRODUCT_PACKAGING AD_PRODUCT_INDUSTRIAL_CONSUMER_GOODS_CORPORATE_IMAGE_ADVERTISING AD_PRODUCT_INDUSTRIAL_CONSUMER_GOODS_GENERAL AD_PRODUCT_PLASTICS AD_PRODUCT_ADHESIVES AD_PRODUCT_ART_CULTURE_ENTERTAINMENT AD_PRODUCT_ART_CULTURE AD_PRODUCT_ART_CULTURE_CORPORATE_IMAGE_ADVERTISING AD_PRODUCT_ART_CULTURE_ENTERTAINMENT_ADVERTISING_RANGE AD_PRODUCT_ENTERTAINMENT AD_PRODUCT_PERSONAL_NEEDS AD_PRODUCT_WATCHES_JEWELRY AD_PRODUCT_MUSICAL_INSTRUMENTS AD_PRODUCT_PERSONAL_NEEDS_OTHER AD_PRODUCT_COLLECTIBLES AD_PRODUCT_WRITING_INSTRUMENTS AD_PRODUCT_TOYS AD_PRODUCT_TOBACCO AD_PRODUCT_CLEANING AD_PRODUCT_CLEANING_GENERAL AD_PRODUCT_CLEANING_CORPORATE_IMAGE_ADVERTISING AD_PRODUCT_DETERGENTS AD_PRODUCT_POLITICAL_PARTIES AD_PRODUCT_CDU AD_PRODUCT_FDP AD_PRODUCT_SPD AD_PRODUCT_ALLIANCE_90_THE_GREENS AD_PRODUCT_THE_LEFT AD_PRODUCT_FREE_DEMOCRATS AD_PRODUCT_ALTERNATIVE_FOR_GERMANY AD_PRODUCT_POLITICAL_PARTIES_OTHER
placement

Physical placement of the device within the venue (venue classification, zone, and product aisles). Owned directly by the device.

object
venue

DOOH venue classification (parent + child tiers from OpenOOH v1.2.1).

string
default: VENUE_UNSPECIFIED
Allowed values: VENUE_UNSPECIFIED VENUE_TRANSIT_UNSPECIFIED VENUE_TRANSIT_AIRPORT VENUE_TRANSIT_BUS VENUE_TRANSIT_TAXI_RIDESHARE_TV VENUE_TRANSIT_SUBWAY VENUE_TRANSIT_TRAIN VENUE_TRANSIT_FERRY VENUE_TRANSIT_TRAM VENUE_TRANSIT_HIGHWAY_REST_AREA VENUE_RETAIL_UNSPECIFIED VENUE_RETAIL_FUELING_STATION VENUE_RETAIL_CONVENIENCE_STORE VENUE_RETAIL_GROCERY VENUE_RETAIL_LIQUOR_STORE VENUE_RETAIL_MALL VENUE_RETAIL_CANNABIS_DISPENSARY VENUE_RETAIL_PHARMACY VENUE_RETAIL_PARKING_GARAGE VENUE_RETAIL_FURNITURE VENUE_RETAIL_APPAREL VENUE_RETAIL_AUTOMOTIVE VENUE_RETAIL_LAUNDROMAT VENUE_RETAIL_VAPE_SHOP VENUE_RETAIL_MASS_MERCHANDISING VENUE_RETAIL_CONSUMER_ELECTRONIC VENUE_RETAIL_OTHER VENUE_RETAIL_SPORTING_GOOD VENUE_RETAIL_PET_STORE VENUE_RETAIL_OFFICE_SUPPLY VENUE_RETAIL_HOME_RENOVATION VENUE_OUTDOOR_UNSPECIFIED VENUE_OUTDOOR_BILLBOARD VENUE_OUTDOOR_URBAN_PANEL VENUE_OUTDOOR_BUS_SHELTER VENUE_OUTDOOR_SPECTACULAR VENUE_OUTDOOR_WINDOW_PANEL VENUE_OUTDOOR_MOVING_BILLBOARD VENUE_OUTDOOR_CAR_TOP VENUE_OUTDOOR_AERIAL VENUE_OUTDOOR_EV_CHARGING_STATION VENUE_HEALTH_BEAUTY_UNSPECIFIED VENUE_HEALTH_BEAUTY_GYM VENUE_HEALTH_BEAUTY_SALON VENUE_HEALTH_BEAUTY_SPA VENUE_HEALTH_BEAUTY_TATTOO VENUE_POINT_OF_CARE_UNSPECIFIED VENUE_POINT_OF_CARE_DOCTOR_OFFICE VENUE_POINT_OF_CARE_VETERINARY_OFFICE VENUE_POINT_OF_CARE_DENTIST_OFFICE VENUE_POINT_OF_CARE_HOSPITAL VENUE_POINT_OF_CARE_URGENT_CARE VENUE_POINT_OF_CARE_PHYSIOTHERAPY VENUE_EDUCATION_UNSPECIFIED VENUE_EDUCATION_SCHOOL VENUE_EDUCATION_COLLEGE_AND_UNIVERSITY VENUE_OFFICE_BUILDING_UNSPECIFIED VENUE_OFFICE_BUILDING_COMMERCIAL VENUE_OFFICE_BUILDING_WAREHOUSE VENUE_ENTERTAINMENT_UNSPECIFIED VENUE_ENTERTAINMENT_RECREATIONAL_LOCATION VENUE_ENTERTAINMENT_MOVIE_THEATER VENUE_ENTERTAINMENT_SPORTS VENUE_ENTERTAINMENT_BAR VENUE_ENTERTAINMENT_CASUAL_DINING VENUE_ENTERTAINMENT_QSR VENUE_ENTERTAINMENT_HOTEL VENUE_ENTERTAINMENT_GOLF_CART VENUE_ENTERTAINMENT_NIGHT_CLUB VENUE_ENTERTAINMENT_CASINO VENUE_ENTERTAINMENT_CONVENTION_CENTER VENUE_GOVERNMENT_UNSPECIFIED VENUE_GOVERNMENT_DMV VENUE_GOVERNMENT_MILITARY_BASE VENUE_GOVERNMENT_POST_OFFICE VENUE_GOVERNMENT_FIRST_RESPONDER_FACILITY VENUE_FINANCIAL_UNSPECIFIED VENUE_FINANCIAL_BANK VENUE_RESIDENTIAL_UNSPECIFIED VENUE_RESIDENTIAL_APARTMENT_AND_CONDO
retailGroceryZone

VenueRetailGrocery lists grandchild venue types under Retail:Grocery.

string
default: VENUE_RETAIL_GROCERY_UNSPECIFIED
Allowed values: VENUE_RETAIL_GROCERY_UNSPECIFIED VENUE_RETAIL_GROCERY_ENTRANCE VENUE_RETAIL_GROCERY_CHECK_OUT VENUE_RETAIL_GROCERY_AISLES VENUE_RETAIL_GROCERY_EXTERIOR
retailMallZone

VenueRetailMalls lists grandchild venue types under Retail:Mall.

  • VENUE_RETAIL_MALLS_CONCOURSE: Large open area including hallways and escalators.
  • VENUE_RETAIL_MALLS_FOOD_COURT: Common area with multiple food vendors and tables.
  • VENUE_RETAIL_MALLS_SPECTACULAR: Large impactful screens at prime locations.
string
default: VENUE_RETAIL_MALLS_UNSPECIFIED
Allowed values: VENUE_RETAIL_MALLS_UNSPECIFIED VENUE_RETAIL_MALLS_CONCOURSE VENUE_RETAIL_MALLS_FOOD_COURT VENUE_RETAIL_MALLS_SPECTACULAR
aisles

Product aisles the device serves (e.g. PRODUCE, DAIRY). Grocery venues only.

Array<string>
Allowed values: AISLE_UNSPECIFIED AISLE_ALCOHOL AISLE_BABY AISLE_BAKERY AISLE_BAKING AISLE_BEVERAGE AISLE_BREAD AISLE_BREAKFAST AISLE_BUTCHER AISLE_BUTTER AISLE_CANNED AISLE_CHEESE AISLE_CONDIMENTS AISLE_DAIRY AISLE_DELI AISLE_FROZEN AISLE_GRAINS AISLE_HOUSEHOLD_CLEANING AISLE_MEAT AISLE_PASTA AISLE_PERSONAL_CARE AISLE_PET AISLE_PRODUCE AISLE_SEAFOOD AISLE_SNACK
Example
{
"device": {
"type": "DEVICE_TYPE_UNSPECIFIED",
"status": "STATUS_UNSPECIFIED",
"deployment": {
"allocationTargets": [
{
"nonStatic": {
"balancePolicy": "AD_SERVER_BALANCE_POLICY_UNSPECIFIED"
}
}
]
},
"supportedAdTypes": [
{
"adType": "AD_TYPE_UNSPECIFIED"
}
],
"sensors": [
"SENSOR_UNSPECIFIED"
],
"playoutImpressionFactors": [
{
"day": "DAY_OF_WEEK_UNSPECIFIED"
}
],
"excludedAdProducts": [
"AD_PRODUCT_UNSPECIFIED"
],
"placement": {
"venue": "VENUE_UNSPECIFIED",
"retailGroceryZone": "VENUE_RETAIL_GROCERY_UNSPECIFIED",
"retailMallZone": "VENUE_RETAIL_MALLS_UNSPECIFIED",
"aisles": [
"AISLE_UNSPECIFIED"
]
}
}
}